#pragma once

#include "hack/exception/exception.hpp"
#include "trs/utils/var.hpp"

namespace trs
{
  template<typename FunctionManager, typename Transaction>
  void execute(FunctionManager& fm, Transaction& tr)
  { 
    try
    {
      fm.execute(tr); 
    } 
    catch (hack::exception& ex)
    {
      throw ex;
    }
    catch (std::exception& e) 
    { 
      hack::exception ex;
      ex.description("it can be very dangerous. this error when we execute function");
      ex.message(var::EXECUTE_ERROR);
      ex.system_error(e);
      throw ex;
    }
    catch (...) 
    { 
      hack::exception ex;
      ex.description(var::ALIEN_SYSTEM_ERROR);
      ex.message(var::EXECUTE_ERROR);
      throw ex;
    } 
  }
}
