#pragma once

#include "hack/exception/exception.hpp"
#include "trs/utils/var.hpp"

namespace trs
{
  template<typename Inspector, typename FunctionManager, typename Transaction>
  void verification(Inspector& ins, FunctionManager& fm, Transaction& tr)
  {
    try
    {
      fm.valid(tr.m_passport.m_function_name);
      ins.valid(tr); 
    } 
    catch (hack::exception& ex)
    {
      throw ex;
    }
    catch (std::exception& e) 
    { 
      hack::exception ex;
      ex.description("this payload failed verification");
      ex.system_error(e);
      throw ex;
    }
    catch (...) 
    { 
      hack::exception ex;
      ex.description(var::ALIEN_SYSTEM_ERROR + " : payload failed verification");
      throw ex;
    } 
  }
}
